
	// gestione delle preferenze

var gAppName = 'Zodiac';
var gAppVersion = '0.03';

var gPref = new WidgetPreference(gAppName, gAppVersion,{

	lastSign: 0,
	timeBetweenChecks: 1000 * 60 * 30,		// 30 minuti
	
	lastUpdateCheck: -1

});

var gWindow;

// TBD: schedulare con un timer asincrono o inserire il check nelle preferenze

var debugNV = false;

function ChkNV() {

	var d = new Date();

	var lastCheck = gPref.Get('lastUpdateCheck');
	if (d.getTime() - lastCheck > (debugNV ? 5 * 1000 : 1000 * 60 * 60 * 24)) { // 1 giorno (se debug, 5 secondi)
//	if (d.getTime() - lastCheck > 1000) {
	
		var newVersionData = CheckForNewVersion(gAppName, gAppVersion, gPref.GetUniqueSerial(), debugNV);
		if (newVersionData != 'NONE') {

			var versionAvailable = newVersionData.split('|')[0];
			var versionLink = newVersionData.split('|')[1];
		
			$('newVersionId').innerHTML = versionAvailable;
			$('newVersionLink').onclick = function() { widget.openURL(versionLink); return false; };

			$('newVersion').style.display = 'block';
			$('horoscope').style.display = 'none';

//				// ridimensiona l'area per permettere al 
//				// messaggio di essere visto
//
//			gWindow.ResizeTo(-1, gWindow.Height() + $('newVersion').offsetHeight);
		}

		alert('CheckForNewVersion(): Risultato: ' + newVersionData);
	
		gPref.Set('lastUpdateCheck', d.getTime());
	}
}

// check di nuova versione un minuto dallo start (se debug, 5 secondi)
var updTimer = setInterval('ChkNV()', debugNV ? (5 * 1000) : (60 * 1000));	// 1 minuto dopo l'avvio dell'applicazione

	// startup

window.onload = OnLoad;

if (window.widget) {

	widget.onhide = OnHide;
	widget.onshow = OnShow;

} else {}

function OnLoad() {

	if (window.widget)
		alert("Start with serial [" + gPref.GetUniqueSerial() + "]!");

	$('widgetVersion').innerHTML = gAppVersion;

	$('frmSign').selectedIndex = gPref.Get('lastSign', 0);

	gWindow = new Window({});
//	alert("Width: " + gWindow.Width() + "  Height: " + gWindow.Height());

	OnShow();
}

function OnShow() {

	OptionChanged();
}

function OnHide() {}

function OptionChanged() {

	gPref.Set('lastSign', $('frmSign').selectedIndex);

	$('sign').innerHTML = $('frmSign').options[ $('frmSign').selectedIndex ].value;

	var sign = $('frmSign').options[ $('frmSign').selectedIndex ].value.toLowerCase();

	DoLoad();
}

function DoLoad() {

	var sign = $('frmSign').options[ $('frmSign').selectedIndex ].value.toLowerCase();

	LoadHoroscope(sign);
	
		// schedula il prossimo check

	var zodiacTimer = setInterval('DoLoad()', gPref.Get('timeBetweenChecks'));
}

//

var gRequest = null;

function LoadHoroscope(sign) {

//	alert('Doing query for sign ' + sign + ' ...');
	
	if (gRequest !== null)
		alert("gRequest is not null");

//	var urlText = url.fetch( "http://horoscopes.astrology.com/dailylong" + whatToGet.toLowerCase() + ".html" );

	var pars = {
	
		asynchronous: true,
		onComplete: QueryDone,
		method: 'get'
	};

	gRequest = new Ajax.Request('http://horoscopes.astrology.com/dailylong' + sign + '.html', pars);
}

function QueryDone(transport) {

//alert("Query done");

if (window.widget)
	alert("Query Done!");

    if (transport.status == 200) {

		ParseResult(transport.responseText);

//    	alert('Risultato: ' + transport.responseText);

    } else {

			var msg = 'Error in loading: ' + transport.status
    	for (v in transport)
				msg += v + ': ' + transport[v] + '\n';

    	alert(msg);
    }

	gRequest = null;
}

function ParseResult(v) {

		var re = new RegExp('(<daily_horoscope>)([^<]*)', 'm');
		var res = re.exec( v );

		var text = res[2];

		re = new RegExp('<div class=datehed>([^\n|\r|<]+)', '');
		res = re.exec( v );

		var date = res[1];

//alert("Data: [" + date + "] Oro: [" + text + "]");

	$('date').innerHTML = date;
	$('horoscope').innerHTML = text;
	$('graphimg').src = 'Signs/' + $('frmSign').options[ $('frmSign').selectedIndex ].value + '.png';
} 
